Subject: Re: [PATCH net-next 5/8] net: mscc: Add initial Ocelot switch support

From: Andrew Lunn <[email-masked]>
Date: Fri, 30 Mar 2018 16:50:08 +0200

On Fri, Mar 30, 2018 at 04:16:34PM +0200, Alexandre Belloni wrote:
> On 30/03/2018 at 15:54:22 +0200, Andrew Lunn wrote:
> > > > All of this sounds like it should be moved into the br_join/leave, this
> > > > does not appear to be the right place to do that.
> > > > 
> > > 
> > > No, I've triple checked because this is a comment that both Andrew and
> > > you had. Once a port is added to the PGID MASK, it will start forwarding
> > > frames so we really want that to happen only when the port is in
> > > BR_STATE_FORWARDING state. Else, we may forward frames between the
> > > addition of the port to the bridge and setting the port to the
> > > BR_STATE_BLOCKING state.
> > 
> > Hi Alexandre
> > 
> > Interesting observation. I took a look at some of the other join
> > implementations. mv88e6xxx does the join immediately. mt7539 does it
> > immediately, if the port is enabled. lan9303 does it immediately.
> > qca8k does it immediately. b53 does it immediately.
> > 
> 
> I had a look at b53, my impression was that b53_br_join() adds the port
> to the bridge but b53_br_set_stp_state() actually enables forwarding. So
> as long as the default on the port is PORT_CTRL_DIS_STATE, the port will
> not be forwarding frames. And this is the case because b53_enable_port()
> does put 0 in B53_PORT_CTRL.

https://elixir.bootlin.com/linux/latest/source/drivers/net/dsa/b53/b53_regs.h#L71

It seems like, 0 means no STP at all. Which to me would mean, forward
all packets. But i could be wrong. Florian?

> The fact is that ocelot doesn't have separate controls. The port is
> either forwarding or not. If it is not forwarding, then there is nothing
> to tell the HW to do.

Think about the following sequence:

ip link set lan0 up

After this command, i expect to see packets on lan0 arrive at the
host, tcpdump to work, etc. This probably means the port is in
'forwarding' mode, or for B53, STP is disabled.

ip link add name br0 type bridge
ip link set dev br0 up
ip link set dev lan0 master br0

When the port is added to the bridge, there is a window of time
between the join and the STP change to blocking/learning, when the
port is in forwarding mode. You avoid this window. But the other
drivers don't appear to.

So i would like to fix this of every driver. I'm not sure how yet...

   Andrew